      IMPLICIT REAL*8 (A-G,N-Z),INTEGER*2 (H-L)                                 
      DIMENSION DTV(2,3000,3,2),V(7,2),TVC(3000,2),VCO(3000,2)                  
      DATA V/1.,0.,0.,0.,0.,0.,0., 0.,1.,0.,0.,0.,0.,0. /                       
      DATA H,HH,ITVCT,IVCT,IOCT,IFCT/1,2,0,0,1,0/                               
C                                                                               
C                          PROGRAM TO PERFORM ITERATIVE                         
C                          BARYCENTRIC SUBDIVISION OF A                         
C                          TWO DIMENSIONAL 1-1-1 SIMPEX                         
C                          INITIALIZE SIMPLEX                                   
      DO 1 I=1,3                                                                
      DO 2 J=1,2                                                                
2     DTV(H,1,I,J)=V(I,J)                                                       
1     CONTINUE                                                                  
C                                                                               
C                          READ NUMBER OF ITERATIVE SUBDIVISIONS:               
      READ (5,*) ISTAR                                                          
C                          BEGIN ISTAR ITERATIONS                               
      DO 10 L=1,ISTAR                                                           
C                          DO SUBDIVISION IN GENFAC:                            
      CALL GENFAC (H,HH,ITVCT,IOCT,IFCT,DTV,TVC)                                
      IOVCT=IVCT+1                                                              
C                          SORT THROUGH NEW VERTICES TO ELIMINATE               
C                          REDUNDANCY, SAVE UNIQUE VERTICES IN THE              
C                          ARRAY VCO AND COUNT WITH IVCT.                       
      ICT=ITVCT-1                                                               
      DO 20 I=1,ICT                                                             
      II=I+1                                                                    
      DO 30 J=II,ITVCT                                                          
      DO 40 K=1,2                                                               
40    IF (DABS(TVC(I,K)-TVC(J,K)).GT.1.D-06) GOTO 30                            
C                          TWO MATCHES                                          
      GOTO 20                                                                   
30    CONTINUE                                                                  
C                                                                               
      IVCT=IVCT+1                                                               
      VCO(IVCT,1)=TVC(I,1)                                                      
      VCO(IVCT,2)=TVC(I,2)                                                      
20    CONTINUE                                                                  
      IVCT=IVCT+1                                                               
      VCO(IVCT,1)=TVC(ITVCT,1)                                                  
      VCO(IVCT,2)=TVC(ITVCT,2)                                                  
C                          PRINT BARYCENTRIC COORDINATES FOR EACH               
C                          ITERATION.                                           
      IB=IVCT+12                                                                
      DO 90 I=IOVCT,IB,12                                                       
      IC=I+11                                                                   
      IF (IC.GT.IVCT) IC=IVCT                                                   
      WRITE (6,1010) (VCO(JJ,2),JJ=I,IC)                                        
90    IF (IC.EQ.IVCT) GOTO 99                                                   
C     WRITE (6,1010) (VCO(JJ,2),JJ=IOVCT,IVCT)                                  
99    PRINT,'C          ',IVCT,' AFTER SUBDIVISION:',L                          
1010  FORMAT ('      *',12(F4.3,','))                                           
CC                          INITIALIZE FOR NEXT SUBDIVISION                      
      IOCT=IFCT                                                                 
      IFCT=0                                                                    
      IF (H.EQ.1) GOTO 50                                                       
      H=1                                                                       
      HH=2                                                                      
      GOTO 10                                                                   
50    H=2                                                                       
      HH=1                                                                      
10    CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
      END                                                                       
      SUBROUTINE GENFAC (H,HH,ITVCT,IOCT,IFCT,DTV,TVC)                          
      IMPLICIT REAL*8 (A-G,N-Z),INTEGER*2 (H-L)                                 
      DIMENSION DTV(2,3000,3,2),V(7,2),TVC(3000,2),VCO(3000,2)                  
     *          ,IDB(3,2),IDF(6,3)                                              
      DATA IDF/ 1,4,2,6,3,1, 4,2,6,3,5,5, 7,7,7,7,7,7/,                         
     *     IDB/ 1,1,2, 2,3,3/                                                   
C                          SET TEMPORARY VERTICE COUNTER                        
      ITVCT=0                                                                   
C                          STAR EACH SIMPLEX                                    
      DO 10 I=1,IOCT                                                            
      DO 20 K=1,3                                                               
      DO 30 J=1,2                                                               
30    V(K,J)=DTV(H,I,K,J)                                                       
20    CONTINUE                                                                  
C                          STAR EACH JOIN                                       
      DO 40 J=1,3                                                               
      K=J+3                                                                     
      DO 50 L=1,2                                                               
50    V(K,L)=(V(IDB(J,1),L)+V(IDB(J,2),L))/2.D0                                 
40    CONTINUE                                                                  
C                          STAR BARYCENTER                                      
      DO 60 J=1,2                                                               
60    V(7,J)=(V(1,J)+V(2,J)+V(3,J))/3.D0                                        
C                          GENERATE NEW SIMPLICES                               
      DO 70 J=1,6                                                               
      IFCT=IFCT+1                                                               
      DO 80 K=1,3                                                               
      DTV(HH,IFCT,K,1)=V(IDF(J,K),1)                                            
80    DTV(HH,IFCT,K,2)=V(IDF(J,K),2)                                            
70    CONTINUE                                                                  
C                         SAVE NEW VERTICES                                     
      DO 90 K=4,7                                                               
      ITVCT=ITVCT+1                                                             
      DO 100 J=1,2                                                              
100   TVC(ITVCT,J)=V(K,J)                                                       
90    CONTINUE                                                                  
10    CONTINUE                                                                  
C                                                                                                                                                
      END                        