      program build 
c----------------------------------------------------------------------
c                       ************************
c                       *                      *
c                       *  build.mar.10.1991   *
c                       *                      *
c                       ************************
c----------------------------------------------------------------------
c build is a fortran program which interactively creates the input
c file read from unit n1 by the vertex program.  build reads data
c from three sources n2, *, and n9.  the output file is written to
c unit n1
c-----------------------------------------------------------------------
c files (see vertex program documentation for additional information):
c
c  l.u.n  i/o       purpose
c  -----  ---   --------------------------------------------------------
c   n2     i    data file containing the names, compositional vectors,
c               and standard state thermodynamic data for potentially
c               stable condensed phases and fluid species.
c   n7     i    terminal input for interactive systems.
c   n8     o    terminal output for interactive systems.
c   n9     i    optional data file which contains data on the
c               compositional equations of state and subdivision schemes
c               to be used for solution phases.
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-n)
 
      include 'perplex_parameters.h'

      character*8 exname, dname*40, vname, xname, blank*1, dnames,
     *            title*100, phase, y*1, blah*10, fname(h9)*10,
     *            name, b1, b2, names, uname(k0)*5, tname(i9)*10

      character*100 n3name, n4name, n9name, dpl, dpr, dsol, new*3

      character*5 mname(k5), nname(k5), oname(k5), qname(k0), pname(k5), 
     *            cmpnt, char5, amount*6, nc(3)*2, text*256, dtext*140

      integer icout(k0), id(2)

      double precision c(0:4)
 
      common/ cst6 /icomp,istct,iphct,icp/ cst8 /names(k1)
     *      / cst207 /ctrans(k0,k5),ictr(k5),itrans/ cst60 /ipoint,imyn
     *      / csta2 /xname(k5),vname(l2)/ cst140 /inew
     *      / cst5 /v(l2),tr,pr,r,ps/ cst9 /vmax(l2),vmin(l2),dv(l2)
     *      / cst10 /iff(2),idss(h5),ifug,ifyn,isyn
     *      / cst24 /ipot,jv(l2),iv(l2)/ cst112 /buf(5)
     *      / cst100 /dlnfo2,elag,gz,gy,gx,ibuf,hu,hv,hw,hx    
     *      / cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9    
     *      / cst37 /ixct,iexyn/ cst36 /exname(h8)
     *      / cst43 /therm(k4),comp(k0),atwt(k0),idh2o,idco2,ikind
     *      / csta5 /dname(8),cmpnt(k0)/ cst42 /ic(k5),idbase
     *      / cst314 /dblk(3,k5),cx(2),dx,dy,icont
     *      / cst108 /wg(m1,m3),xmn(mst,msp),xmx(mst,msp),xnc(mst,msp),
     *                iend(m4),isub(m1,m2,2),imd(mst),insp(m4),
     *                ist(mst),isp(mst),isite,iterm,iord,
     *                istot,jstot,kstot
     *      / cst149 /idnam/ cst149a /dnames(h8) 

      data blank/' '/

      data dpr,dpl,dsol/'pr            ','pl           ',
     *                  'newest_format_solut.dat     '/
c-----------------------------------------------------------------------
      write (*,7020)
c                                     assign data files
c                                     get thermo data file choice
      call fopen
c                                     initialization:
      n3name = blank
      n4name = blank
      n9name = blank

      do i = 1, l2
         iv(i) = i
         vmin(i) = 0d0
         vmax(i) = 0d0
         dv(i) = 1d0
      end do 
 
      phase ='  FLUID ' 
      amount = 'molar '
      dtext = ' '

      nc(1) = 'C0'
      nc(2) = 'C1'
      nc(3) = 'C2'
 
      iv(5) = 3
      iind = 0 
      ifyn = 0
      iprct = 0
      iexyn = 0
      ixct = 0
      isudo = 0
      ifugy = 0
      im = 0
      jfix = 0
      isct=0
      imct = 0
      ifct = 0
      io3 = 1
      io3p = 1
      io4 = 1
      isec = 3
      ifull = 0
      imsg = 0
      jpot = 1
      jtest = 3
      ivct = 2
      imode = 0 
      icont = 0
      io3b = 1
      char5 = 'b' 
      jd = 0 
      iphct = 0
      iwt = 0
      jmode = 0
      jlev = 0 
      ilow = 0 
      jlow = 0 
      jcth = 0 
      icth = 0 

      do i = 0, 4
         c(i) = 0d0
      end do 
c                                 Read THERMODYNAMIC DATA (N2)
c                                 and do component transformations:
      call topn2 (3, icmpn)
      jcmpn = icmpn
c                                 Component stuff first, this allows
c                                 us to know variables for calculation
c                                 choice.
      do i = 1, icmpn
         uname(i) = cmpnt(i)
         qname(i) = cmpnt(i)
      end do
c                                 components of saturated phase:
      write (*,2030) phase
      read (*,2100) y

      if (y.eq.'y'.or.y.eq.'Y') then

         id(1) = idh2o
         id(2) = idco2
c                                   write prompt
         write (*,2031) 
         write (*,1040) (uname(id(i)),i=1,2)
         write (*,2021)
c                                   write blurb
         write (*,1030)

         do while (char5.ne.blank.and.ifct.lt.2)
89          read (*,3000) char5 
            if (char5.ne.blank) then 
               do i = 1, 2
                  if (uname(id(i)).eq.char5) then 

                     if (id(i).eq.jd) then 
c                                  user is trying to pick same component
c                                  twice
                        write (*,2310) char5
                        goto 89
                     end if 

c                                  eliminate used components
                     do j = id(i)+1, jcmpn
                        qname(j-1) = qname(j)
                     end do 
                     goto 16
                  end if 
               end do
c                                  invalid name
               write (*,2310) char5
               goto 89
c                                  count component
16             ifct = ifct + 1  
               if (ifct.eq.2) write (*,*)  
               jcmpn = jcmpn - 1
               mname(ifct) = char5
            end if 
         end do 

         if (ifct.ne.0) then 
            ifyn = 1
            iv(3) = 3
            ivct = 3
         end if 

      end if
c                                 saturated components
      write (*,2110)
      read (*,2100) y
 
      if (y.eq.'Y'.or.y.eq.'y') then

         call warn (15,r,i,'BUILD')
 
5007     write (*,2032) h5+1
         write (*,1040) (qname(I),I=1,JCMPN)
         write (*,2021)

         isct = 0
         char5 = 'b' 

         do while (char5.ne.blank.and.isct.lt.h5)
98          read (*,3000) char5 
            if (char5.ne.blank) then 
               do i = 1, jcmpn
                  if (qname(i).eq.char5) then 
c                                  eliminate used components
                     do j = i+1, jcmpn
                        qname(j-1) = qname(j)
                     end do 
                     goto 15
                  end if 
               end do
c                                  invalid name
               write (*,2310) char5
               goto 98
c                                  count component
15             isct = isct + 1    
               jcmpn = jcmpn - 1
               nname(isct) = char5
            end if 
         end do 

         do j = 1, isct
            if (nname(j).eq.uname(idh2o).or.
     *          nname(j).eq.uname(idco2)) call error (18,r,i,nname(j))
         end do
 
      end if
c                                 mobile components:
      write (*,2040)
      read (*,2100) y
 
      if (y.eq.'y'.or.y.eq.'Y') then
c                                 write blurb
         write (*,2200)
c                                 write prompt
         write (*,2050) 
         write (*,1040) (qname(i),i=1,jcmpn)
         write (*,2021)

         char5 = 'b'
         imct = 0 
         
         do while (char5.ne.blank.and.imct.lt.2)
97          read (*,3000) char5 
            if (char5.ne.blank) then 
               do i = 1, jcmpn
                  if (qname(i).eq.char5) then 
c                                  eliminate used components
                     do j = i+1, jcmpn
                        qname(j-1) = qname(j)
                     end do 
                     goto 10
                  end if 
               end do
c                                  invalid name
               write (*,2310) char5
               goto 97
c                                  count component
10             imct = imct + 1    
               if (imct.eq.2) write (*,*) 
               jcmpn = jcmpn - 1
               oname(imct) = char5
            end if 
         end do 
 
         do i = 1, imct
            write (vname(3+i),5000) 'u(',oname(i),')'
            call unblnk (vname(3+i))
            ivct = ivct + 1
         end do
      end if
 
      if (ifyn.eq.0) then 
c                                 no saturated fluid phase 
         iv(3)=4
         iv(4)=5
      else 
c                                 a saturated phase is present
c                                 but may have only one component
         iv(4)=4
         iv(5)=5
      end if
c                                 Thermodynamic components:
94    write (*,2070) 
      write (*,1040) (qname(i),i=1,jcmpn)
      write (*,2021)

      itct = 0 
      char5 = 'b'
      imax = jcmpn 

      do while (char5.ne.blank.and.itct.lt.imax)

96       read (*,3000) char5

         if (char5.ne.blank) then 
         
            do j = 1, jcmpn
               if (qname(j).eq.char5) then
c                                  eliminate used components
                  do i = j+1, jcmpn
                     qname(i-1) = qname(i)
                  end do 
                  goto 95 
               end if 
            end do
c                                  invalid name
            write (*,2310) char5
            goto 96
c                                  good name, count and save index
95          itct = itct + 1
            do i = 1, icmpn
               if (uname(i).eq.char5) then 
                  ic(itct) = i 
                  goto 86
               end if 
            end do 
86          jcmpn = jcmpn - 1
            cmpnt(itct) = char5

         else 
            if (itct.eq.0) then 
               call warn (19,r,k5,'build')
               goto 94
            end if
         end if 

      end do 

      icp = itct
      icomp = icp + isct + imct + ifct
      itcp = icp + isct
c                                  now check for fluid components 
c                                  in thermodynamic composition space.    
      do i = 1, icp
         if (cmpnt(i).eq.uname(idh2o).or.
     *       cmpnt(i).eq.uname(idco2)) then
             call warn (16,r,i,cmpnt(i))
             ifugy = ifugy + 1
         end if
      end do
c                                  get fluid equation of state
      if (ifyn.ne.0.or.ifugy.ne.0) call rfluid (1,ifug,n3)
c                                  eliminate composition variable
c                                  for saturated fluid if constrained
c                                  fugacity EoS is used:
c                                  probably should change iv(3)?
      if ((ifug.ge.7.and.ifug.le.9.or.ifug.eq.24).and.ifct.gt.1) 
     *   ivct = ivct - 1
c                                  jcmpn unused components are in qname
c                                  get the indices for chkphi
      do 33 i = 1, icmpn
         icout(i) = 0
         do j = 1, jcmpn
            if (qname(j).eq.uname(i)) goto 33
         end do 
         icout(i) = 1
33    continue
c                                 ====================================
c                                 ask if p = f(T) or vice versa
5102  idep = 0
      write (*,1050) vname(1),vname(2)
      read (*,2100) y
      if (y.eq.'Y'.or.y.eq.'y') then
5101     write (*,1060) vname(1),vname(2),vname(2),vname(1)
         read (*,*,iostat=ier) idep
         call rerror (ier,*5101)
         if (idep.lt.1.or.idep.gt.2) goto 5102
c                                 reset the variable counters and 
c                                 flags:
         call depend (ivct,idep,iind,iord,c,dtext)

      end if
c                                  ====================================
c                                  next problem class and variable choice
c                                  and ranges
5003  write (*,1490)
      read (*,7010,iostat=ier) icopt
      if (icopt.lt.1.or.icopt.gt.4) icopt = 1
      call rerror (ier,*5003)

      if (icopt.eq.3) then 
c                                  ==================================-
c                                  swash, not a lot to do
         icopt = 4   
      else if (icopt.eq.4) then 
c                                  fractionation, use jcopt
c                                  to choose mode choice
         icopt = 7
         ilow = 99
         jlev = 1
         icont = 1
          
         write (*,1210) 
         write (*,1211) (i,vname(iv(i)), i = 1, ivct)

         if (idep.eq.0) then 
c                                   don't know if user introduced functional
c                                   dependences already so:
            jdep = 2
            write (*,1212) ivct+1,vname(iv(1)),vname(iv(2)),
     *                     ivct+2,vname(iv(2)),vname(iv(1))
         else 
            jdep = 0 
         end if 

         write (*,1213) ivct+jdep+1

         read (*,*) jcopt

         if (jcopt.le.ivct+jdep) then 

            if (jcopt.le.ivct) then 
c                                 simple sectioning path
               ict = 2
               do i = 1, ivct
                  if (iv(i).ne.jcopt) then 
                     iv(ict) = iv(i)
                     ict = ict + 1
                  end if
               end do 
               iv(1) = jcopt
            else 
c                                  path v1 = f(v2) or v2 = f(v1):
c                                  reset the variable counters and 
c                                  flags:
               if (jcopt.eq.ivct+1) then 
c                                  the dependent variable is v1 (p)
                  idep = 1
               else 
c                                  the dependent variable is v2 (T)
                  idep = 2
               end if 

               call depend (ivct,idep,iind,iord,c,dtext)
             
            end if 

            ilow = 1

6021        write (*,2160) vname(iv(1))
            read (*,*,iostat=ier) vmin(iv(1)),vmax(iv(1))
            call rerror (ier,*6021)
            jvct = 1 

            write (*,1220) 
            read (*,*) jlow
c                                 get sectioning variables values:
            do j = 2, ivct
6022           write (*,2180) vname(iv(j))
               read (*,*,iostat=ier) vmin(iv(j))
               call rerror (ier,*6022)
 
               vmax(iv(j)) = vmin(iv(j))
               dv(iv(j)) = 1d0
            end do 
c                                 lastly switch the independent variable
c                                 to the second position so that vertex
c                                 thinks it's the y-axis variable
            junk = iv(1)
            iv(1) = iv(2)
            iv(2) = junk   

         end if 

      else if (icopt.eq.2) then
         icopt = 5
         jvct = 0
         ilow = 0 
         icont = 1
c                                  =====================
c                                  gridded minimization:
         if (ivct.eq.1) then
c                                  only one potential, must be on y
            if (icp.eq.1) call error (38,r,i,'BUILD')

            icont = 2

         else 
c                                  Select the x variable
6017        write (*,2111)
6013        write (*,2140) (j,vname(iv(j)), j = 1, ivct)
            if (icp.ge.2) write (*,1470) j
            if (ifct.eq.1.and.ifyn.eq.1) write (*,7150) vname(3) 
            write (*,1570)
            read (*,*,iostat=ier) jc
            call rerror (ier,*6013)
 
            if (jc.gt.ivct+1.or.jc.lt.1) then
               write (*,1150)
               goto 6017
            else if (jc.eq.ivct+1) then 
               icont = 2
            else 
               jvct = 1
               ix = iv(1)
               iv(1) = iv(jc)
               iv(jc) = ix
6014           write (*,2150) vname(iv(1))
               read (*,*,iostat=ier) vmin(iv(1)),vmax(iv(1))
               call rerror (ier,*6014)
            end if
         end if 

         if (ivct.eq.1.and.icp.eq.2) then 
c                                 the y variable must be iv(1)     
6019        write (*,2150) vname(iv(1))
            read (*,*,iostat=ier) vmin(iv(1)),vmax(iv(1))
            call rerror (ier,*6019)
            jvct = 1      
         else 
c                                 select the y variable 
            if (ivct.gt.1.or.icont.eq.2.and.icp.gt.2) then
               jst = 2
               if (icont.eq.2) jst = 1
6018           write (*,2130)
6015           write (*,2140) (j,vname(iv(j)), j = jst, ivct)
               if (icp.gt.2.and.icont.eq.2) write (*,1480) j
               write (*,*) ' '
               read (*,*,iostat=ier) jc
               call rerror (ier,*6015)
 
               if (jc.gt.ivct+1.or.jc.lt.jst) then
                  write (*,1150)
                  goto 6018
               else if (jc.eq.ivct+1) then
                  icont = 3
               end if

            else if (icont.eq.2) then
 
               jc = 1 

            else 

               jc = 2
 
            end if

            if (icont.lt.3) then 
               ind = 2
               if (icont.eq.2) ind = 1
               ix = iv(ind)
               iv(ind) = iv(jc)
               iv(jc) = ix
               jvct = jvct + 1
6016           write (*,2150) vname(iv(ind))
               read (*,*,iostat=ier) vmin(iv(ind)),vmax(iv(ind))
               call rerror (ier,*6016)
            end if  
         end if
c                                 get sectioning variables values:
         do j = jvct+1, ivct
6023        write (*,2180) vname(iv(j))
            read (*,*,iostat=ier) vmin(iv(j))
            call rerror (ier,*6023)
 
            vmax(iv(j)) = vmin(iv(j))
            dv(iv(j)) = 1.
         end do 
c                                  get grid refinement mode                
4003     write (*,3070) 
         read (*,7010,iostat=ier) kmode
         call rerror (ier,*4003)
c                                  Select grid refinement mode: (help)
c                                  1 - Refine only true phase boundaries, compression on.
c                                  2 - Refine only true phase boundaries, compression off [default].
c                                  3 - Refine all phase boundaries, compression on.
c                                  4 - Refine all phase boundaries, compression off.
         if (kmode.lt.1.and.kmode.gt.4) kmode = 2

         if (kmode.eq.1) then 
            jmode = 1 
            jtest = 1
         else if (kmode.eq.2) then 
            jmode = 1
            jtest = 3
         else if (kmode.eq.3) then 
            jmode = 0
            jtest = 1
         else if (kmode.eq.4) then 
            jmode = 0 
            jtest = 3
         end if 
c         if (jmode.ne.1) jmode = 0
c
c                                  check compression               
c4004     write (*,3110) 
c         read (*,2100) y
c         if (y.eq.'Y'.or.y.eq.'y') jtest = 3
c                                  get y-grid parameters
4005     write (*,3080) l7
6004     read (*,7010,iostat=ier) ilow
         call rerror (ier,*6004)

         write (*,3085) l7
6006     read (*,7010,iostat=ier) jlow
         call rerror (ier,*6006)

         if (jlow.le.1.or.jlow.gt.l7) jlow = 40
         if (ilow.le.0.or.ilow.gt.l7) ilow = 40

         write (*,3090) l8
6005     read (*,7010,iostat=ier) jlev
         call rerror (ier,*6005)
         if (jlev.le.0.or.jlev.gt.l8) jlev = 4

         loopy = (jlow-1) * 2**(jlev-1) + 1
         loopx = (ilow-1) * 2**(jlev-1) + 1

         if (loopy.gt.l7) then 
            call warn (92,r,loopy,'Y-AXIS')
            jlow = (l7 - 1)/2**(jlev-1) + 1
            loopy = (jlow-1) * 2**(jlev-1) + 1
         end if 

         if (loopx.gt.l7) then 
            call warn (92,r,loopx,'X-AXIS')
            ilow = (l7 - 1)/2**(jlev-1) + 1
            loopx = (ilow-1) * 2**(jlev-1) + 1
         end if 

         write (*,3100) loopx,loopy
         read (*,2100) y
         if (y.eq.'Y'.or.y.eq.'y') goto 4005              

      else if (icopt.eq.1) then    
c                                  =========================
c                                  Normal computational mode
6003     write (*,1500)
         if (ivct.gt.1) write (*,1590)
         read (*,7010,iostat=ier) icopt

         call rerror (ier,*6003)

         if (icopt.gt.ivct) goto 6003

         if (icopt.lt.1.or.icopt.gt.2) icopt = 0

         if (icopt.eq.2) then 
            icopt = 1
         else if (icopt.eq.1) then 
            icopt = 3
         end if 

         if (icopt.eq.1) then
c                                  Select the x variable (IV(1)):
5017        write (*,2111)
 
5013        write (*,2140) (j,vname(iv(j)), j = 1, ivct)
            if (ifct.eq.1.and.ifyn.eq.1) write (*,7150) vname(3) 
            read (*,*,iostat=ier) jc
            call rerror (ier,*5013)
 
            if (jc.gt.ivct.or.jc.lt.1) then
               write (*,1150)
               goto 5017
            end if
 
            ix = iv(1)
            iv(1) = iv(jc)
            iv(jc) = ix
 
5014        write (*,2150) vname(iv(1))
            read (*,*,iostat=ier) vmin(iv(1)),vmax(iv(1))
            call rerror (ier,*5014)
c                                 select the y variable (iv(2)):
            if (ivct.gt.2) then
 
5018           write (*,2130)
5015           write (*,2140) (j,vname(iv(j)), j = 2, ivct)
               read (*,*,iostat=ier) jc
               call rerror (ier,*5015)
 
               if (jc.gt.ivct.or.jc.lt.2) then
                  write (*,1150)
                  goto 5018
               end if
 
            else
 
               jc=2
 
            end if
 
            ix = iv(2)
            iv(2) = iv(jc)
            iv(jc) = ix
 
5016        write (*,2150) vname(iv(2))
            read (*,*,iostat=ier) vmin(iv(2)),vmax(iv(2))
            call rerror (ier,*5016)
c                                 define default variable increments:
            do i = 1, 2
               dv(iv(i)) = (vmax(iv(i)) - vmin(iv(i))) / 40d0          
            end do 
c                                 specify sectioning variables (iv(3)):
            do j = 3, ivct
5022           write (*,2180) vname(iv(j))
               read (*,*,iostat=ier) vmin(iv(j))
               call rerror (ier,*5022)
 
               vmax(iv(j)) = vmin(iv(j))
               dv(iv(j)) = 1.
            end do 

         else if (icopt.eq.3) then
c                                 select the y variable (iv(1)):
5027        write (*,2210)
 
5023        write (*,2140) (j,vname(iv(j)), j = 1, ivct)
            if (ifct.eq.1.and.ifyn.eq.1) write (*,7150) vname(3) 
            read (*,*,iostat=ier) jc
            call rerror (ier,*5023)
 
            if (jc.gt.ivct.or.jc.lt.1) then
               write (*,1150)
               goto 5027
            end if
 
            ix = iv(1)
            iv(1) = iv(jc)
            iv(jc) = ix
 
5024        write (*,2150) vname(iv(1))
            read (*,*,iostat=ier) vmin(iv(1)),vmax(iv(1))
            call rerror (ier,*5024)
c                                 define default variable increment:
            dv(iv(1)) = (vmax(iv(1)) - vmin(iv(1))) / 40d0
c                                 specify sectioning variable (iv(2)):
            do j = 2, ivct
 
5029           write (*,2180) vname(iv(j))
               read (*,*,iostat=ier) vmin(iv(j))
               call rerror (ier,*5029)
 
               vmax(iv(j)) = vmin(iv(j))
               dv(iv(j)) = 1d0
            end do 
         end if
      end if 
c                                 check that X(O) is not 0 or 1
c                                 for fluid speciation routines:
      if (ifyn.eq.1.and.(ifug.ge.10.and.ifug.ne.13.and.ifug.ne.14
     *    .and.ifug.ne.15.and.ifug.ne.18)) then
         if (vmin(3).eq.vmax(3)) then
            if (vmin(3).lt.1d-6) then
               vmin(3) = 1d-6
               vmax(3) = vmin(3)
             else if (vmin(3).gt.0.999999) then
               vmin(3) = 0.999999
               vmax(3) = vmin(3)
             end if
          else 
             if (vmin(3).lt.1d-6) vmin(3) = 1d-6
             if (vmax(3).gt.0.999999) vmax(3) = 0.999999
          end if
      end if
c                                  =========================
c                                  Compositional constraints
      if (icopt.ne.4) then 
         icth = icp + isct
         if (icopt.ne.5.and.icopt.ne.7) then
            write (*,1510)
            read (*,2100) y
            if (y.ne.'Y'.and.y.ne.'y') goto 6030
            jcth = 0
            icont = 1
            write (*,1380)
         else if (isct.ne.0) then 
            write (*,1450)
            read (*,2100) y 
            if (y.ne.'y'.and.y.ne.'Y') then 
               jcth = icp
            else
               write (*,1460)
            end if 
         else 
            jcth = icp 
         end if 

         do i = 1, icp
            pname(i) = cmpnt(i)
         end do 

         do i = icp + 1, icp + isct
            pname(i) = nname(i-icp)
         end do

         if (icopt.ne.5.and.icopt.ne.7) then 
            istart = 1
         else 
            istart = icp + 1
         end if 

         if (jcth.ne.icp)  then 

            do i = istart, icth
               write (*,1430) pname(i)
               read (*,2100) y
               if (y.eq.'Y'.or.y.eq.'y') then
                  jcth = jcth + istart
               else 
                  exit
               end if 
            end do 

         end if 
c                                ask if weight amounts, otherwise
c                                use molar amounts.
         write (*,1420) 
         read (*,2100) y
         if (y.eq.'Y'.or.y.eq.'y') then 
            iwt = 1
            amount = 'weight'
         end if 
c                                get the bulk composition:
         if (icont.eq.1) then 
c                                fixed bulk composition
5041        write (*,1390) amount
            write (*,1040) (pname(j), j = 1, jcth)
            write (*,1410) 
            read (*,*,iostat=ier) (dblk(1,j), j = 1, jcth)
            call rerror (ier,*5041)
         else 
c                                user must define compositional variables
            if (icont.eq.2) then
               write (*,1520)
            else 
               write (*,1540)
            end if 
 
            do i = 1, icont
6041           write (*,1390) amount
               write (*,1040) (pname(j), j = 1, jcth)
               write (*,1530) nc(i)
               read (*,*,iostat=ier) (dblk(i,j), j = 1, jcth)
               call rerror (ier,*6041)
            end do 
         end if 
      end if 
c                                  ================================
c                                  print and plot file assignment 
c                                  and options:
6030  write (*,2000) 'print'
      read (*,2100) y
      if (y.eq.'Y'.or.y.eq.'y') then
         io3 = 0

         write (*,2010) 'print','pr'
         read (*,3040) n3name
         if (n3name.eq.blank) n3name = dpr

         if (icopt.eq.1) then 
c                                print file format, only an
c                                option on SPDP's
            write (*,1200) 
            read (*,2100) y
            if (y.eq.'Y'.or.y.eq.'y') io3p = 0
         end if 

         if (icont.ne.0) then 
            write (*,1110) 
            read (*,2100) y
            if (y.eq.'Y'.or.y.eq.'y') io3b = 0
         end if

         if (icopt.eq.1.or.icopt.eq.3) then

            write (*,7090) 
            read (*,2100) y
            if (y.eq.'Y'.or.y.eq.'y') then
               ifull = 1
               call warn (174,r,ifull,n3name)
               write (*,7120)
               read (*,2100) y
               if (y.eq.'Y'.or.y.eq.'y') ifull = 2
               write (*,7100) 
               read (*,2100) y
               if (y.eq.'Y'.or.y.eq.'y') ifull = ifull + 2
            end if 

            write (*,7130)
            read (*,2100) y
            if (y.eq.'Y'.or.y.eq.'y') imsg = 1

         end if

         write (*,7030) 
         read (*,2100) y
         if (y.eq.'Y'.or.y.eq.'y') jpot = 0

      end if 
c                                if the user doesn't want print
c                                output, ask for plot file name
c                                by default.
      if (io3.eq.0) then  
         write (*,2000) 'plot'
         read (*,2100) y
         if (y.eq.'Y'.or.y.eq.'y') io4 = 0
      else
         io4 = 0
      end if 
 
      if (io4.eq.0) then
         write (*,2010) 'plot','pl'
         read (*,3040) n4name
         if (n4name.eq.blank) n4name = dpl
c                                  warn about non-plottable results:
         if (icopt.eq.0.and.icp.ne.3) then
            call warn (37,r,i,'BUILD')
         else if (icopt.eq.3.and.icp.ne.2) then
            call warn (38,r,i,'BUILD')
         else if (jcth.gt.0.and.jcth.lt.icp) then
            call warn (39,r,i,'BUILD')
         end if 
      end if
c                                  warn the user he has not requested 
c                                  a plot file.
      if (jcth.ge.icp.and.io4.eq.1) call warn (89,r,k5,'build')
c                                  =============
c                                  security level
      if (icopt.eq.1) then

7001     write (*,7000)
         read (*,7010,iostat=ier) isec
         call rerror (ier,*7001)
         if (isec.gt.5.or.isec.lt.1) isec = 3

      end if 
c                                  ======================================
c                                  now start phase data:
c                                  first get consistent phases
      write (*,*) ' '
 
35    call getphi (name,ibase,icmpn,*34)
 
      call chkphi (0,name,tot,icout,ibase,icmpn,*35)
 
      iphct = iphct + 1
      names(iphct) = name
 
      goto 35
c                                 Excluded phases:
34    write (*,2080)
      read (*,2100) y
 
      if (y.eq.'Y'.or.y.eq.'y') then
 
         write (*,2034)
         read (*,2100) y
 
         if (y.ne.'y'.and.y.ne.'Y') then
            name = 'b'
            write (*,2021)
 
            do while (ixct.lt.h8.and.name.ne.blank) 

               read (*,2100) name
               if (name.ne.blank) then 
                  do i = 1, iphct
                     if (names(i).eq.name) then 
                        ixct = ixct + 1
                        exname(ixct) = name
                        goto 36
                     end if 
                  end do 
                  write (*,1020) name
               end if 
36          end do

            if (ixct.eq.h8) call warn (8,r,h8,'BUILD')

         else
            do i = 1, iphct
 
               write (*,1130) names(i)
               read (*,2100) y
 
               if (y.eq.'Y'.or.y.eq.'y') then
                  ixct = ixct + 1
                  if (ixct.gt.h8) then 
                     call warn (8,r,h8,'BUILD')
                     ixct = ixct - 1
                     exit
                  end if 
                  exname(ixct) = names(i)
               end if
 
           end do 
 
        end if
 
      end if
c                                read solution phases.
      write (*,2500)
      read (*,2100) y
 
      if (y.eq.'y'.or.y.eq.'Y') then
c                                 get the file containing the solution models
18       write (*,3010)
         read (*,3040) n9name
         if (n9name.eq.blank) n9name = dsol
         write (*,*) 
         open (n9,file=n9name,iostat=ierr,status='old')
 
         if (ierr.ne.0) then
c                                 system could not find the file
            write (*,3020) n9name
 
5033        write (*,7050)
            read (*,2100,iostat=ier) y
            call rerror (ier,*5033)
 
            if (y.ne.'Y'.and.y.ne.'y') goto 999
            goto 18
c                                 try again
         end if
 
         ict = 0
         ipoint = iphct

c         if (ifugy.eq.0) then
c                                 this was here to prevent users
c                                 from making h2o and/or co2 mobile
c                                 but using the components in a fluid.
c                                 changed as of 5/31/04, JADC.
c            b1 = uname(idh2o)
c            b2 = uname(idco2)
c         else
            b1 = ' '
            b2 = ' '
c         end if 
c                                 test file format
         read (n9,'(a)') new
         inew = 0 
         if (new.ne.'new'.and.new.ne.'NEW') then
            write (*,1051) 
            inew = 1
         end if 
c                                 read candidates:
110      call rmodel (blah)
c                                 istot = 0 = eof
         if (istot.ne.0) then 
c                                 check for endmembers:
            call cmodel (im,idsol,blah,1,b1,b2)
            if (jstot.eq.0) goto 110
      
            ict = ict + 1
            if (ict.gt.i9) call error (24,r,i9,'build')

            tname(ict) = blah 

            goto 110
         end if 
c                                   we have the list, ask user for choices
90       if (ict.eq.0) then
 
            write (*,7040)
 
         else
 
            write (*,2510)
            write (*,2520) (tname(i), i = 1, ict)
            write (*,*)
 
            isoct = 0 
            blah = 'b'

191         read (*,2100) blah
            if (blah.eq.blank) goto 192
 
            do i = 1, ict
               if (blah.eq.tname(i)) goto 194
            end do 

            do i = 1, isoct
               if (blah.eq.fname(i)) goto 191
            end do 
 
            write (*,*) blah,' is not a valid name, try again'
            goto 191

194         isoct = isoct + 1
            fname(isoct) = blah
            if (isoct.gt.h9) call error (25,r,h9,'BUILD')
            goto 191

192         if (icopt.eq.1.and.isoct.gt.0.and.jcth.lt.icp) then 
c                                  allow setting of variance flag
c                                  only for icopt 1 (schreinemakers)
               isudo = 1
               write (*,7060) 
               read (*,2100) Y
               if (y.eq.'y'.or.y.eq.'Y') isudo = 0
            else 
               isudo = 0
            end if 
         end if
c                                  solutions involve dependent endmembers,
c                                  ask for exclusions:
         if (idnam.ne.0) then  
            write (*,1600) 
            write (*,1610) (dnames(i),i=1,idnam)
            write (*,1620) 
            write (*,1625)
            read (*,2100) y
 
            if (y.eq.'y'.or.y.eq.'Y') then
               name = 'b'
               write (*,2021)
 
               do while (ixct.lt.h8.and.name.ne.blank) 

                  read (*,2100) name
                  if (name.ne.blank) then 
                     do i = 1, idnam
                        if (dnames(i).eq.name) then 
                           ixct = ixct + 1
                           exname(ixct) = name
                           goto 46
                        end if 
                     end do 
                     write (*,1020) name
                  end if 
46             end do
               if (ixct.eq.h8) call warn (8,r,h8,'BUILD')
            end if 
         end if  
      end if
c                                  get title
      write (*,7070) 
      read (*,2100) title
c                               output options etc:
c                               thermodynamic data file is output by fopen
c                               first.
      call mertxt (text,n3name,'print file name, blank = no output')
      write (n1,3040) text
      call mertxt (text,n4name,'plot file name, blank = no output')
      write (n1,3040) text
      call mertxt (text,n9name,
     *            'solution model file, blank = no solutions')
      write (n1,3040) text
c                               if special dependencies, put them in the
c                               title
      if (title.eq.' '.and.idep.ne.0) then 
         call mertxt (text,dtext,'title')
      else if (title.eq.' ') then
         text = 'Title Text'
      else if (idep.eq.0) then 
         text = title
      else
         call mertxt (text,title,dtext)
      end if 

      write (n1,3040) text
      write (n1,1010) icopt,'calculation type, 0 - no independent',
     *                ' potentials, 1 - two independent potentials', 
     *                ' 3 - one independent potentials, 4 - swash',
     *                ' 5 - gridded minimization, 7 - fractionation' 
      write (n1,1010) isec,'efficiency level, 0 - low, 5 - high'
      write (n1,1010) jpot,'print potentials, 0 - yes, 1 - no'
      write (n1,1010) jtest,'JTEST, debug or compression flag (off=3)'
      write (n1,1010) ifull,'reaction format,',
     *            ' 0 - just names, 1 - sat. phases',
     *            ' 2 -  S and V, 3 - stoichiometry, 4 - everything' 
      write (n1,1010) imsg,'console messages, 0 - yes,',
     *                     ' 1 - suppress most'
      write (n1,1010) io3p,'short print file, 0 - no, 1 - yes'
      write (n1,1010) jmode,'for gridded minimization ',
     *        'grid refinement, 1 - true boundaries, 0 - all boundaries'
      write (n1,1010) jlow,'for gridded minimization ',
     *                     'JLOW, number of Y-nodes at lowest level'
      write (n1,1010) jlev,'for gridded minimization ',
     *                     'JLEV, number of grid levels'
      write (n1,1010) itrans,'number component transformations'
      write (n1,1010) icmpn,'number of components'      
      if (itrans.gt.0) then
         do i = 1, itrans
            write (n1,1120) uname(ictr(i)), ictr(i)
            write (n1,1125) (ctrans(j,i), j = 1, icmpn)
         end do 
      end if 
      write (n1,1010) iwt,'component amounts, 0 - molar, 1 weight'
      write (n1,1010) io3b,'assemblage data 0 - print, 1 - suppress'
      write (n1,1010) isudo,'variance flag, 0 - calculate all,',
     *                      ' 1 - only true univariants'
      write (n1,1010) idbase,'IDBASE data base code'
c                                 output saturated phase eos choice:
      if (ifyn.eq.0.and.ifugy.eq.0) then
         write (n1,1010) 0,'ifug EoS for saturated phase'
      else
         write (n1,1010) ifug,'ifug EoS for saturated phase'
            if (ifug.ge.7.and.ifug.le.12.and.ifug.ne.9.or.
     *          ifug.eq.14.or.ifug.eq.16.or.ifug.eq.17.or.
     *          ifug.eq.24.or.ifug.eq.24.or.ifug.eq.25) 
     *         write (n1,1330) ibuf, hu, dlnfo2, elag,
     *              'ibuf, ipro, choice dependent parameter, ln(ag)'
               if (ibuf.eq.5) write (n1,4020) buf,'a-e'
      end if
c                                 potential variable dependencies
      write (n1,1010) ilow,'for gridded minimization ',
     *                     'ILOW, number of X-nodes at lowest level'
      write (n1,1010) idep,'special dependencies: ',
     *                '0 - P and T independent, 1 - P(T), 2 - T(P)'
      write (n1,1560) c
c                                 output component data:
      write (n1,3060) 'thermodynamic component list'

      do i = 1, icp 
         if (i.gt.jcth) then 
            write (n1,3000) cmpnt(i),0,0.,0.,0.,'unconstrained'
         else 
            write (n1,3000) cmpnt(i),icont,(dblk(j,i),j=1,3),amount
         end if 
      end do 
      write (n1,3050) 'thermodynamic component list'

      write (n1,3060) 'saturated component list'

      do i = 1, isct

         if (i+icp.gt.jcth) then 
            write (n1,3000) nname(i),0,0.,0.,0.,'unconstrained'
         else 
            write (n1,3000) nname(i),icont,(dblk(j,i+icp),j=1,3),amount
         end if

      end do 

      write (n1,3050) 'saturated component list'

      write (n1,3060) 'saturated phase component list'
      do i = 1, ifct
         write (n1,2100) mname(i)
      end do 
      write (n1,3050) 'saturated phase component list'

      write (n1,3060) 'mobile component list'
      do i = 1, imct
         write (n1,2100) oname(i)
      end do 
      write (n1,3050) 'mobile components'

      write (n1,3060) 'excluded phase list'
      do i = 1, ixct
         write (n1,2100) exname(i)
      end do 
      write (n1,3050) 'excluded phase list'

      write (n1,3060) 'solution phase list'
      do i = 1, isoct
         write (n1,2100) fname(i)
      end do 
      write (n1,3050) 'solution phase list'
c                                 output variable choices and values:
      write (n1,4020) (vmax(i), i= 1, l2),'max p, t, xco2, u1, u2'
      write (n1,4020) (vmin(i), i= 1, l2),'min p, t, xco2, u1, u2'
      write (n1,4020) (dv(i), i= 1, l2),'increment p, t, xco2, u1, u2'
      write (n1,1310) (iv(i), i = 1, l2),'iv1, iv2, iv3, iv4, iv5'
c                                 get conditions for composition
c                                 diagrams:
      if (icopt.eq.0) then

         if (ifct.eq.1.and.ifyn.eq.1) write (*,7150) vname(3) 

         i = 0

         do 

            i = i + 1
 
            write (*,6020) (vname(iv(j)),j=1,ivct)
5036        write (*,6010) i
            read (*,*,iostat=ier) (vmin(iv(j)),j=1,ivct)
            call rerror (ier,*5036)
            if (vmin(iv(1))+vmin(iv(2)).eq.0d0) goto 99 
            write (n1,1340) vmin

         end do 
      end if
 
99    endfile (n1)
 
      close (n1)
 
999   stop

1010  format (i5,1x,a,a,a,a,a)
1020  format (a,' does not exist in the selected data base')
1030  format (/,'For C-O-H fluids it is only necessary to select ',
     *       'volatile species present in',/,'the solids of interest. ',
     *       'If the species listed here are H2O and CO2, then to',/,
     *       'constrain O2 chemical potential to be consistent with ',
     *       'C-O-H fluid speciation',/,'treat O2 as a saturated ',
     *       'component. Refer to the Perple_X Tutorial for details.',/)
1040  format (12(1x,a5))
1050  format (/,'The data base has ',a,' and ',a,' as default ',
     *       'independent potentials.',/,'Make one dependent on the ',
     *       'other, e.g., as along a geothermal gradient (y/n)?')
1051  format (//,'WARNING, you are using a solution model file with',
     *         /,'the old Perple_X format, this format will not be ',
     *         /,'supported in future versions. You should correct ',
     *         /,'the file format of your file, or copy a new version',
     *         /,'from the Perple_X web site.',//)
1060  format (/,'Select dependent variable:',//,'  1 - ',a,' = f(',a,')'
     *       ,/,'  2 - ',a,' = f(',a,')',/)
1110  format ('Print pseudodivariant assemblage data (y/n)? ')
1120  format (a,1x,i2,' component transformation')
1125  format (13(f6.2,1x))
1130  format ('Exclude ',a,' (Y/N)? ')
1150  format (/,'huh? ',/)
1195  format (/,'To relax or change these constraints modify ',a,'.'/)
1200  format ('Long print file format (Y/N)? ')
1210  format (/,'Fractionation calculations are path dependent, select '
     *         ,'path type:',/)
1211  format (5x,i1,' - path with variable ',a,
     *              ', all other variables constant')
1212  format (5x,i1,' - path with ',a,' = f(',a,')',
     *              ', all other variables constant')
1213  format (5x,i1,' - arbitrary user specified coordinates',/)
1220  format ('How many points along the path?')
1310  format (/,5(i2,1x),2x,a,/)
1330  format (i2,1x,i2,1x,g13.6,1x,g13.6,1x,a)
1340  format (5(g13.6,1x))
1380  format (/,'The next prompts define the components to',
     *        ' be constrained.',/,'Answering no at any point',
     *        ' will complete the set of constraints.',
     *      /,'The prompts are for thermodynamic components,',
     *        ' followed by',/,'saturated components, in the ',
     *        ' order entered above.',/,
     *        'E.g., to constrain Fe:Mg',
     *        ' enter FEO and MGO as the first two',/,
     *        'thermodynamic components, and specify',
     *        ' the amounts of both.',/)
1390  format (/,'Enter ',a,' amounts of the components:')
1410  format ('for the bulk composition of interest:')
1420  format (/,'Specify component amounts by weight (Y/N)?')
1430  format ('Constrain component ',a,' (Y/N)? ')
1450  format (/,'In this mode all thermodynamic components must be ',
     *         'constrained,',/'constrain ',
     *         'saturated components also (Y/N)?')
1460  format (/,'The next prompts are for the saturated',
     *        ' component constraints.',/,
     *        'Answering no at any point',
     *        ' completes the set of constraints.',/)
1470  format (5x,i1,' - Composition X(C1)* (user defined)')
1480  format (5x,i1,' - Composition X(C2) (user defined)')
1490  format (//,'Specify computational mode:',//,
     *        5x,'1 - Unconstrained minimization [default]',/, 
     *        5x,'2 - Constrained minimization on a grid',/,
     *        5x,'3 - Output pseudocompound data',/,
     *        5x,'4 - Phase fractionation calculations',//,
     *        'Unconstrained optimization should be used for the ',
     *        'calculation of composition,',/,'mixed variable, and ',
     *        'Schreinemakers diagrams, it may also be used for the',/, 
     *        'calculation of phase diagram sections for a fixed bulk ',
     *        'composition. Gridded',/,'minimization can be used to ',
     *        'construct phase diagram sections for both fixed',/,
     *        'and variable bulk composition. Gridded minimization is ',
     *        'preferable for the',/,'recovery of phase and bulk ',
     *        'properties.',/)
1500  format (//,'Specify number of independent potential variables:',
     *         /,5x,'0 - Composition diagram [default]',/,
     *           5x,'1 - Mixed-variable diagram')
1510  format (/,'Constrain bulk composition (as in pseudosections,',
     *          ' y/n)?')
1520  format (/,'The bulk composition of the system will be computed ',
     *       'as:',/,'   C = C0*(1-X(C1)) + C1*X(C1)',/,
     *       'where X(C1) varies between 0 and 1, and C0 and C1 are ',
     *       'the compositions',/,'specified next.')
1530  format ('to define the composition ',a)
1540  format (/,'The bulk composition of the system will be computed ',
     *       'as:',/,'   C = C0 + C1*X(C1) + C2*X(C2)',/,
     *       'where X(C1) and X(C2) vary between 0 and 1, and C0, C1 ',
     *       'and C2 are the',/,'compositions specified next.')
1550  format (/,'Gridded minimization requires at two independent ',
     *       'variables, but you have',/,'configured a problem with ',
     *       'only one independent variable.',/)
1560  format (5(g12.6,1x),'Geothermal gradient polynomial coeffs.')
1570  format (/,'*X(C1) can not be selected as the y-axis variable',/)
1590  format (5x,'2 - Sections and Schreinemakers-type diagrams')
1600  format (/,'The solution model file defines the following ',
     *        'dependent endembers:',/)
1610  format (7(1x,a8))
1620  format (/,'Exclude any of these endmembers (y/n)?')
1625  format ('Answer no if you do not understand this prompt.',/)
2000  format (/,'Do you want a ',a,' file (Y/N)? ')
2010  format ('Enter the ',a,' file name, < 100 characters, left ',
     *        'justified [default = ',a,']: ')
2021  format ('Enter names, left justified, 1 per line,',
     *        ' <cr> to finish:')
2030  format (/,'Calculations with a saturated phase',
     *        ' (Y/N)?',/,'The phase is: ',a,/,
     *        'Its compositional variable is: Y(CO2), X(O), etc.')
2031  format (/,'Select the independent saturated phase components:')
2032  format (/,'Select < ',i1,' saturated components from the set:')
2034  format ('Do you want to be prompted for phases (Y/N)? ')
2040  format (/,'Use chemical potentials, activities or fugacities as',
     *        ' independent',/,'variables (Y/N)? ')
2050  format ('Select < 3 mobile components from the set:')
2070  format (/,'Select thermodynamic components from the set:')
2080  format (/,'Exclude phases (Y/N)? ')
2100  format (a)
2110  format (/,'Calculations with saturated components (Y/N)? ')
2111  format (/,'Select x-axis variable:')
2120  format ('Enter component name, left justified: ')
2130  format (/,'Select y-axis variable:')
2140  format (5x,I1,' - ',a)
2150  format (/,'Enter minimum and maximum values, respectively,',
     *        ' for: ',a)
2160  format (/,'Enter start and end values, respectively,',
     *        ' for: ',a)
2180  format (/,'Specify sectioning value for: ',a)
2210  format (/,'Select vertical axis variable: ')
2220  format ('Calculate sections as a function of a',
     *          ' second variable (Y/N)? ')
2200  format (/,'Chemical potentials are symbolized in Perple_X, by a',
     *        ' lowercase u followed by the',/,'component name in',
     *        ' parentheses, e.g., the potential of A is written',
     *        ' u(A).',//,'To convert chemical potentials to',
     *        ' activities or fugacities run the Perple_X program',/,
     *        'MU_2_F after running VERTEX (see on-line documentation',
     *        ' for additional information).',/)
2310  format (/,a,' is invalid. Check spelling, upper/lower',
     *        ' case matches. Try again:',/)
2500  format (/,'Do you want to treat solution phases (Y/N)? ')
2510  format (/,'Select phases from the following list, enter',
     *        ' 1 per line,',/,'left justified, <cr>',
     *        ' to finish',/)
2520  format (6(2x,a))
3000  format (a,1x,i1,1x,3(g12.6,1x),a,' amount')
3010  format ('Enter solution model file name [default = ',
     *        'newest_format_solut.dat]',/,'left justified, ',
     *        '< 100 characters: ')
3020  format (/,'**error ver191** FOPEN cannot find file:',/,a,/)
3040  format (a,10x,a)
3050  format ('end ',a,/)
3060  format (/,'begin ',a)
c3070  format (/,'In this mode VERTEX uses a multilevel grid to',
c     *       ' define true phase boundaries',/,'or pseudocompound',
c     *       ' assemblage boundaries, the first option is more ',
c     *       'efficient,',/,'the second option should be selected ',
c     *       'if physicochemical properties are to be',/,
c     *       'retrieved from the section.',//,
c     *       'Select grid refinement mode:',/,5x,
c     *       '1 - Refine only true phase boundaries.',/,5x,
c     *       '2 - Refine all phase boundaries [default].',/)
3070  format (/,'In this mode VERTEX uses a multilevel grid to',
     *       ' define true phase boundaries',/,'or pseudocompound',
     *       ' assemblage boundaries, mode 1 is the most ',
     *       'efficient,',/,'modes 2->4 should be selected ',
     *       'if physicochemical properties are to be',/,
     *       'retrieved from the section. Cost and accuracy increase',
     *       ' with the mode number.',//,
     *       'Turn compression off for numerically sensitive ',
     *       'calculations (e.g., seismic velocities).',
     *  //,'Select grid refinement mode:',//,
     *  5x,'1 - Refine only true phase boundaries, compression on',/,
     *  5x,'2 - Refine only true phase boundaries, compression off',
     *        ' [default]',/,
     *  5x,'3 - Refine all phase boundaries, compression on',/,
     *  5x,'4 - Refine all phase boundaries, compression off',/)
3080  format (/,'The resolution of the grid is determined by',
     *       ' the number of levels (JLEV) and',/,'the resolution at',
     *       ' the lowest level in the X- and Y-directions (ILOW',
     *       ' and JLOW,',/,'respectively), such that the maximum',
     *       ' resolution is equivalent to that obtained',/,
     *       'on a single level grid with 1+(ILOW-1)*2^(JLEV-1) ',
     *       'nodes in the X-direction',/,'and 1+(JLOW-1)*2^(JLEV-1',
     *       ') nodes in the Y-direction. To force VERTEX to use a',/,
     *       'single level grid,',
     *       ' set JLEV=1.',//,'Enter the number of nodes (ILOW)',
     *       ' in the X-direction for the',/,'lowest resolution grid ',
     *       '(0<ILOW<',i4,') [default = 40]:')
3085  format (/,'Enter the number of nodes (JLOW)',
     *       ' in the Y-direction for the',/,'lowest resolution grid ',
     *       '(1<JLOW<',i4,') [default = 40]:')
3090  format (/,'Enter the number of levels (JLEV) for the grid',
     *       ' (0<JLEV<',i2,') [default = 4]:')
3100  format (/,'These parameters define a multilevel grid equivalent',
     *       ' to a regular',/,'X-Y grid with ',i4,' x',i4,' nodes,',
     *       ' change the parameters (y/n)? ')
c3110  format (/,'Turn data compression off (y/n)?',//,'Compression '
c     *       'reduces file size, but may cause unstable extrapolation.'
c     *    ,/,'Turn compression off for numerically sensitive ',
c     *       'calculations (e.g., seismic velocities).',/)
4020  format (2(g11.5,1x),f10.8,1x,2(g11.5,1x),a)
5000  format (a2,a5,a1)
6020  format (/,'Specify values for:',/,(10x,5(a,2x)))
6010  format ('For calculation ',i2,', enter zeros to finish.')
7000  format (/,
     *   'Specify efficiency level [1-5, default = 3]:',/,
     *   '  1 - gives lowest efficiency, highest reliability',/
     *   '  5 - gives highest efficiency, lowest reliability',/
     *   'High values increase probability that a curve',/,
     *   'may be partially determined or skipped.')
7010  format (bn,i80)
7020  format (//,'NO is the default (<cr>) answer to all Y/N prompts',/)
7030  format ('Print dependent potentials for chemographies (Y/N)?',/,
     *        'Answer no if you do not know what this means. ')
7040  format (/,'The solution model file contains no',
     *               ' models valid for your problem.',/)
7050  format ('Try again (Y/N)? ')
7060  format ('Calculate high variance phase fields (Y/N)?')
7070  format (/,'Enter calculation title: ')
7090  format ('Write full reaction equations (Y/N)?')
7100  format ('With stoichiometries (Y/N)?')
7120  format ('With entropy and negative volume (Y/N)?')
7130  format ('Suppress console status messages (Y/N)?')
7140  format ('How many additional variables (<3)? ')
7150  format (/,'*Although only 1 component is specified for the ',
     *       'saturated fluid phase, the',/,' equation of state ',
     *       'permits fluid composition to vary through the variable ',
     *       a,'.',/,' For pure fluids, specify the appropriate ',
     *       'composition as a sectioning constraint.',/) 
7160  format (/,'Select computational mode:',//,3x,'1 - polygonalized'
     *         ,' phase diagram section [default].',/,3x,'2 -',
     *          ' minimization on a regular grid',//,'Mode 1 is',
     *          ' may be preferable for computing sections, whereas',
     *          ' mode 2 is',/,'preferable for the recovery of',
     *          ' phase and bulk properties.',/)

      end
 
      block data
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-n)
      common/ cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
c-----------------------------------------------------------------------
c                              the following data statement assigns
c                              logical unit numbers for i/o.
      data n1,n2,n3,n4,n5,n6,n7,n8,n9/21,22,23,24,25,26, 5, 6,29/
 
      end
 
      subroutine fopen
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-n)
 
      character*100 n2name, y*1, ddata*14, din*14, blank*1, text*140
 
      common/ cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9

      data ddata, din, blank/'hp02ver.dat   ','in            ',' '/
c-----------------------------------------------------------------------
c                                 now the input data file to
c                                 be created for vertex.
10    write (*,1040)
      read (*,1020) n2name
      if (n2name.eq.blank) n2name = din
      open (n1,file=n2name,iostat=ierr,status='new')
      if (ierr.ne.0) then
         write (*,1050) n2name
         read (*,1020) y
         if (y.eq.'Y'.or.y.eq.'y') goto 10
         open (n1,file=n2name)
      end if
c                                 next the thermo data file
1     write (*,1000)
      read (*,1020) n2name
      if (n2name.eq.blank) n2name = ddata
      open (n2,file=n2name,iostat=ierr,status='old')
      if (ierr.ne.0) then
c                                 system could not find the file
         write (*,1010) n2name
         read (*,1020) y
         if (y.ne.'Y'.and.y.ne.'y') goto 999
         goto 1
c                                 try again
      end if
 
      call mertxt (text,n2name,'thermodynamic data file')
      write (n1,1020) text
 
      return
 
999   write (*,1060)
 
      stop
 
1000  format (/,'Enter thermodynamic data file name',
     *          ', left justified, [default = hp02ver.dat]:')
1010  format (/,'**warning ver191** FOPEN cannot find file ',/,a
     *         ,//,'try again (y/n)?')
1020  format (a,10x,a)
1040  format (/,'Enter name of computational option file to be creat',
     *       'ed,'/,'< 100 characters, left justified [default = in]:')
1050  format (/,'File:',/,a,/,'exists, do not overwrite it (y/n)? ')
1060  format (/,'O.K., I quit too.')
 
      end
 
      subroutine grxn (g)
c--------------------------------------------------------------------
c a dummy routine to allow rk to be linked with rlib.f
c--------------------------------------------------------------------
      double precision g
      g = g
      end

      subroutine depend (ivct,idep,iind,iord,c,dtext)
c---------------------------------------------------------------------------
c subroutine to reset variable flags and counters if one variable is
c made dependent on another; the routine also prompts and reads the 
c functional dependence
c---------------------------------------------------------------------------
      implicit none

      include 'perplex_parameters.h'

      character xname*8, dtext*140, vname*8

      integer i, j1, j2, ivct, iind, idep, iord, ipot, jv, ier, iv

      double precision c(0:4), vmax, vmin, dv, ps, r, tr, pr, v
 
      common/ csta2 /xname(k5),vname(l2)
     *      / cst5 /v(l2),tr,pr,r,ps/ cst9 /vmax(l2),vmin(l2),dv(l2)
     *      / cst24 /ipot,jv(l2),iv(l2)
c                                 reset the variable counters and 
c                                 flags:
      ivct = ivct - 1
      if (idep.eq.1) then 
         iind = 2
         j1 = 1
         j2 = 2
         do i = 1, ivct 
            iv(i) = iv(i+1)
         end do 
      else 
         iind = 1
         j1 = 2
         j2 = 1
         do i = 2, ivct 
            iv(i) = iv(i+1)
         end do 
      end if 

      iv(ivct+1) = idep
c                                  now get the functional dependence
5103  write (*,1070) vname(j1),vname(j2)
      read (*,*,iostat=ier) iord
      call rerror (ier,*5103)
      if (iord.lt.0.or.iord.gt.3) goto 5103
      do i = 0, iord
5104     write (*,1080) i
         read (*,*,iostat=ier) c(i)
         call rerror (ier,*5104)
      end do 
c                                  write a text version for the title
      write (dtext,1580) vname(idep),vname(iind),c(0),
     *                      (c(i),vname(iind),i,i=1,iord)
      call unblnk (dtext)

1080  format ('Enter c(',i2,')')
1070  format (/,'The dependence must be described by the polynomial',//,
     *        a,' = Sum ( c(i) * [',a,']^i, i = 0..n)',//,
     *       'Enter n (<5)')
1580  format (a,'(',a,') = ',g12.6,4(' + ',g12.6,' * ',a,'^',i1))
2100  format (a)

      end 
